require "erubis"

module DataStory
  class EvalContext
    
    # Public: Evaluates the passed code in this context.
    def self.evaluate(code)
      prev_stdout = $stdout
      #prev_stderr = $stderr
      
      out = StringIO.new
      $stdout = out
      #$stderr = out
      
      eval(code, eval_binding)
      
      $stdout = prev_stdout
      #$stderr = prev_stderr
      
      out.string
    end
    
    # Public: Evaluates some ERb in this context.
    def self.evaluate_erb(code)
      erb = Erubis::EscapedEruby.new(code)
      erb.result(eval_binding)
    end
    
    def self.eval_binding
      @binding ||= eval("binding")
    end
  end
end